#ifndef BENC_H_
#define BENC_H_

/* http://wiki.theory.org/BitTorrentSpecification#bencoding */

/** defines type of token */
enum { END, INTEGER, STRING, LIST, DICTIONARY } type;

typedef char char_t;

typedef long long integer_t;

typedef struct string {
	int len;
	char_t *str;
} string_t;

typedef struct list {
	int len;
	struct listelem *head;
} list_t;

typedef struct dictionary {
	int len;
	struct dictelem *head;
} dictionary_t;

typedef struct data {
	char type;
	union {
		integer_t *i;
		struct string *s;
		struct list *l;
		struct dictionary *d;
	} ptr;
} data_t;

typedef struct listelem {
	struct data value;
	struct listelem *next;
} listelem_t;

typedef struct dictelem {
	string_t *key;
	struct data value;
	struct dictelem *next;
} dictelem_t;

#define LE_NEXT_POS (sizeof(data_t))

#endif /* BENC_H_ */
